//Befehle

Blockly.Blocks['moveForward'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("moveForward");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("ein Feld in Blickrichtung gehen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['turnLeft'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("turnLeft");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("um 90° nach links drehen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['turnAround'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("turnAround");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("um 180° drehen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['turnRight'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("turnRight");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("um 90° nach links drehen");
        this.setHelpUrl("");
    }
};

Blockly.Blocks['dropBeeper'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("dropBeeper");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("einen Beeper ablegen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['pickBeeper'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("pickBeeper");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("einen Beeper aufnehmen");
        this.setHelpUrl("");
    }
};

//Test-Befehle

Blockly.Blocks['frontIsClear'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("frontIsClear");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn vor Karel keine Wand ist");
        this.setHelpUrl("");
    }
};

Blockly.Blocks['leftIsClear'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("leftIsClear");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn links von Karel kein Wand ist");
        this.setHelpUrl("");
    }
};

Blockly.Blocks['rightIsClear'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("rightIsClear");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn rechts von Karel keine Wand ist");
        this.setHelpUrl("");
    }
};

Blockly.Blocks['onBeeper'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("onBeeper");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn ein Beeper auf dem Feld liegt, auf dem Karel steht");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['beeperAhead'] = {
    init: function () {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("beeperAhead");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn ein Beeper auf dem Feld vor Karel liegt");
        this.setHelpUrl("");
    }
};


//Generator stub : Befehle

Blockly.JavaScript['moveForward'] = function (block) {
    var code = 'moveForward();\n';
    return code;
};
Blockly.JavaScript['turnLeft'] = function (block) {

    var code = 'turnLeft();\n';
    return code;
};
Blockly.JavaScript['turnAround'] = function (block) {

    var code = 'turnAround();\n';
    return code;
};
Blockly.JavaScript['turnRight'] = function (block) {

    var code = 'turnRight();\n';
    return code;
};
Blockly.JavaScript['pickBeeper'] = function (block) {
    var code = 'pickBeeper();\n';
    return code;
};
Blockly.JavaScript['dropBeeper'] = function (block) {
    var code = 'dropBeeper();\n';
    return code;
};

//Generator stub : Test-Befehle

Blockly.JavaScript['frontIsClear'] = function (block) {
    var code = 'frontIsClear()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['leftIsClear'] = function (block) {
    var code = 'leftIsClear()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['rightIsClear'] = function (block) {
    var code = 'rightIsClear()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['onBeeper'] = function (block) {
    var code = 'onBeeper()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['beeperAhead'] = function (block) {
    var code = 'beeperAhead()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};

//Interpreter

function initApi(interpreter, scope) {

    var wrapperTurnLeft = function (text) {
        text = text ? text.toString() : '';
        return turnLeft();
    };
    interpreter.setProperty(scope, 'turnLeft', interpreter.createNativeFunction(wrapperTurnLeft));

    var wrapperTurnRight = function (text) {
        text = text ? text.toString() : '';
        return turnRight();
    };
    interpreter.setProperty(scope, 'turnRight', interpreter.createNativeFunction(wrapperTurnRight));

    var wrapperTurnAround = function (text) {
        text = text ? text.toString() : '';
        return turnAround();
    };
    interpreter.setProperty(scope, 'turnAround', interpreter.createNativeFunction(wrapperTurnAround));

    var wrapperMoveForward = function (text) {
        text = text ? text.toString() : '';
        return moveForward();
    };
    interpreter.setProperty(scope, 'moveForward', interpreter.createNativeFunction(wrapperMoveForward));

    var wrapperPickBeeper = function (text) {
        text = text ? text.toString() : '';
        return pickBeeper();
    };
    interpreter.setProperty(scope, 'pickBeeper', interpreter.createNativeFunction(wrapperPickBeeper));

    var wrapperDropBeeper = function (text) {
        text = text ? text.toString() : '';
        return dropBeeper();
    };
    interpreter.setProperty(scope, 'dropBeeper', interpreter.createNativeFunction(wrapperDropBeeper));

    var wrapperFrontIsClear = function (text) {
        text = text ? text.toString() : '';
        return frontIsClear();
    };
    interpreter.setProperty(scope, 'frontIsClear', interpreter.createNativeFunction(wrapperFrontIsClear));

    var wrapperLeftIsClear = function (text) {
        text = text ? text.toString() : '';
        return leftIsClear();
    };
    interpreter.setProperty(scope, 'leftIsClear', interpreter.createNativeFunction(wrapperLeftIsClear));

    var wrapperRightIsClear = function (text) {
        text = text ? text.toString() : '';
        return rightIsClear();
    };
    interpreter.setProperty(scope, 'rightIsClear', interpreter.createNativeFunction(wrapperRightIsClear));

    var wrapperOnBeeper = function (text) {
        text = text ? text.toString() : '';
        return onBeeper();
    };
    interpreter.setProperty(scope, 'onBeeper', interpreter.createNativeFunction(wrapperOnBeeper));

    var wrapperBeeperAhead = function (text) {
        text = text ? text.toString() : '';
        return beeperAhead();
    };
    interpreter.setProperty(scope, 'beeperAhead', interpreter.createNativeFunction(wrapperBeeperAhead));
}
